Subject: bug#76928: User accounts are shared between system generations

From: Ludovic Courtès <[email-masked]>
Date: Mon, 17 Mar 2025 20:41:48 +0100

Hi,

Ian Eure <[email-masked]> skribis:

> Found this one on accident today and was surprised.  To reproduce:
>
> - Remove your user account from your system configuration on
>   accident.
> - `sudo guix system reconfigure'
> - Realize your mistake.  Observe that neither `su' nor `sudo'  work,
>  because you don’t exist.
> - Reboot in a state of mild panic.
> - Select any previous system generation from GRUB.
>
> Expected result: previous generations should have the account which
> was deleted, since it was declared in the configurations which
> produced them.
>
> Actual result: They don’t.

Are you sure?  /etc/{shadow,passwd,group} are created at activation
time, meaning when booting or reconfiguring (see ‘account-activation’,
which returns code that calls ‘activate-users+groups’, the procedure
that creates those files).

Thanks,
Ludo’.